/*
    libNZ - experimental cryptography library
    Copyright (C) 2021  Sylvain Saucier

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#![allow(dead_code)]

pub struct Primes {
  list: Vec<u32>,
}
impl Primes {

  pub fn new() -> Primes {
    Primes { list: vec![2u32, 3] }
  }

  fn grow(&mut self, index: usize) {
    let mut candidate = 2u32 + self.list[ self.list.len()-1 ];
    while !(index < self.list.len()) {
      let mut is_prime = true;
      let mut denominator = 3u32;

      while denominator < candidate / 2 {
        if candidate % denominator == 0 {
          is_prime = false;
          break;
        }
        denominator = denominator + 2
      }

      if is_prime == true {
        self.list.push(candidate);
      }
      candidate = candidate + 2;
    }
  }
  
  pub fn get(&mut self, index: usize) -> u32 {
    self.grow(index);
    return self.list[index];
  }
}
